module testbench;

    reg D;           // Data input
    reg clk;         // Clock input
    wire Q;         // Q output
    wire Qn;        // Qn output

    // Instantiate the master-slave latch
    latch_MS1 uut (
        .D(D),
        .clk(clk),
        .Q(Q)
    );

    // Clock generation
    initial begin
        clk = 0;
        forever #5 clk = ~clk; // Toggle clock every 5 time units
    end

    // Test sequence
    initial begin
        // Initialize
        D = 0;

        // Wait for a few clock cycles
        #10;

        // Test case 1: Set data to high
        D = 1;         
        #10; // Wait a clock period
        $display("D=%b, Q=%b", D, Q); // Check outputs

        // Test case 2: Change data to low
        D = 0;
        #10; 
        $display("D=%b, Q=%b", D, Q); 

        // Test case 3: Keep data high
        D = 1;         
        #10; 
        $display("D=%b, Q=%b", D, Q); 

        // Test case 4: Final state check
        D = 0;
        #10;
        $display("D=%b, Q=%b", D, Q); 

        // End simulation
        $stop; 
    end

endmodule