module testbench;

    reg S;          // Установка
    reg R;          // Сброс
    wire Q;        // Выход Q
    wire Qn;       // Выход Qn

    // Инстанцирование SR-триггера
    sr_latch uut (
        .S(S),
        .R(R),
        .Q(Q),
        .Qn(Qn)
    );

    initial begin
        // Инициализация
        S = 0; 
        R = 0;

        // Сакк тестовые ситуации
        #10 S = 1; R = 0; // Установить Q в 1
        #10 S = 0; R = 1; // Сбросить Q в 0
        #10 S = 0; R = 0; // Установить хранение состояния
        #10 S = 1; R = 0; // Установить Q в 1 снова
        #10 S = 0; R = 1; // Сбросить Q в 0

        $finish; // Завершить симуляцию
    end

    // Триггер для печати значений
    initial begin
        $monitor("Time: %0t | S = %b, R = %b | Q = %b, Qn = %b", $time, S, R, Q, Qn);
    end

endmodule